Unit Gconst;
Interface
Uses Objects,OMemory,OWindows,ODialogs,WinTypes,WinProcs,WinDos,strings,BWCC,Win31,
GEval,GLobal,Gparse3,GCross,GMutate,GSelect,GGene,Gpool1,GMeasure;
{constants used for Gwin}
Const
  {Menu constants}
  cm_LoadDLL  = 701;
  cm_LoadFunc = 702;
  cm_FuncStat = 703;

  cm_selCross  = 102;
  cm_selMutate = 103;
  cm_selSelect = 101;
  cm_General   = 104;
  cm_status    = 105;
  cm_About     = 999;
  cm_hh        = 905;
  cm_hindex    = 901;
  cm_Run       = 130;

  cm_Vtext     = 110;
  cm_VGraph1   = 111;
  cm_Vgraph2   = 112;
  cm_Vgraph3   = 113;

  cm_Rlog      = 120;

  Run_err_Ofs  = 100; {offset for run error string table}
Var

  {Globally visible objects}
  Info : Pinfo;
  Eval : PEval;
  Parser : PParser;
  Cross : PRecombine;
  Mutate : PMutate;
  Select : PSelect;
  GeneList : PGeneList;
  Pool1,Pool2 : PPool;
  Measure: PMeasure;


{functions for setting and getting dialog text boxes, should be general unit but
yet to get round to movinf them}
Function IntGet(parentwnd : Hwnd; dlgID : Integer;
                MinVal,MaxVal : Integer;Var Result : Integer;Msg:Pchar):Boolean;
Function RealGet(parentwnd : Hwnd; dlgID : Integer;
                 MinVal,MaxVal : Real;Var Result : Real;Msg:Pchar):Boolean;
Procedure IntSet(parentwnd : Hwnd; dlgID : Integer; Result:integer);
Procedure RealSet(parentwnd : Hwnd; dlgID :Integer; Result:Real;Sig : integer);

Implementation

Function IntGet(parentwnd : Hwnd; dlgID : Integer;
                MinVal,MaxVal : Integer;Var Result : Integer;Msg:Pchar):Boolean;
Var
  Code : integer;
  Quant : Array[0 .. 10] of char;
  S : String;
  Rate : Integer;
Begin
  IntGet := FALSE;
  Code := GetDlgItemText(parentwnd,dlgID,Quant,10);
  S:=StrPas(Quant);
  Val(S,Rate,Code);
  If Code <> 0 Then
  Begin
    BWCCMessageBox(Parentwnd,'Invalid data, Should be a number',
               msg,mb_IconExclamation+mb_ok);
    Exit;
  End;
  If (Rate < MinVal) or (Rate > MaxVal) Then
  Begin
    BWCCMessageBox(Parentwnd,'Value is out of allowable range',
               msg,mb_IconExclamation+mb_ok);
    Exit;
  End;
  IntGet := TRUE;
  Result := Rate;
end;

Function RealGet(parentwnd : Hwnd; dlgID : Integer;
                 MinVal,MaxVal : Real;Var Result : Real;Msg:Pchar):Boolean;
Var
  Code : integer;
  Quant : Array[0 .. 10] of char;
  S : String;
  Rate : Real;
Begin
  RealGet := FALSE;
  Code := GetDlgItemText(parentwnd,dlgID,Quant,10);
  S:=StrPas(Quant);
  Val(S,Rate,Code);
  If Code <> 0 Then
  Begin
    BWCCMessageBox(Parentwnd,'Invalid data, Should be a number',
               msg,mb_IconExclamation+mb_ok);
    Exit;
  End;
  If (Rate < MinVal) or (Rate > MaxVal) Then
  Begin
    BWCCMessageBox(Parentwnd,'Value is out of allowable range',
               msg,mb_IconExclamation+mb_ok);
    Exit;
  End;
  RealGet := TRUE;
  Result := Rate;
End;

Procedure IntSet(parentwnd : Hwnd; dlgID : Integer; Result:integer);
Var
 Temps: String;
 Tempstr : array [0..20] of char;
Begin
 Str(Result,TempS);
 SetDlgItemText(ParentWnd,DlgID,StrPCopy(TempStr,TempS));
End;

Procedure RealSet(parentwnd : Hwnd; dlgID :Integer; Result:Real;Sig : integer);
Var
 Temps: String;
 Tempstr : array [0..20] of char;
Begin
 Str(Result:5:sig,TempS);
 SetDlgItemText(ParentWnd,DlgID,StrPCopy(TempStr,TempS));
End;

end.