Unit GDiag1;
Interface
uses Objects,OMemory,OWindows,ODialogs, WinTypes, WinProcs, WinDos, oStdDlgs, oStdWnds, Strings,
Gconst,BWCC,GEval,Global,ggene, GParse3;

Const
{Function Selector}
fs_DllName   = 201; { DLL name}
fs_FuncCount = 202; {Number of functions in DLL}
fs_FuncList  = 203; {Function List}
fs_info      = 204; {Function info button}

{Function Details}
fd_Name    = 501; {Function name}
fd_Type    = 502; {Function Type}
fd_Length  = 503; {Function Length}
fd_Count   = 504; {Function's Count of parameters}
fd_Param   = 505; {Function's parameters} 
fd_Purpose = 506; {Functions Purpose}

{Function Status}
ft_DLLName    = 302;
ft_DLLstatus  = 301;
ft_FuncName   = 304;
ft_FuncStatus = 303;

{Status }
st_select      = 305;
st_crosstype   = 306;
st_crossrate   = 307;
st_mutatetype  = 308;
st_mutaterate  = 309;
st_popsize     = 310;

{Setup Boxes)}
st_List = 102;
st_Edit = 104;

{general setup}
ge_PopSize     = 102;
ge_Trials      = 103;
ge_Generations = 106;
ge_seed        = 107;
ge_setSeed     = 108;
ge_converge    = 105;


Type

  PGetFuncDialog = ^TGetFuncDialog;
  TGetFuncDialog = Object(TDialog)
           Fname: Pchar;
           FList: PListBox;
    Constructor Init(Aparent: PwindowsObject; AName : Pchar; FileName : Pchar);
    Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
    Procedure GetInfo(Var Msg:TMessage); Virtual id_first + fs_info;
    Procedure loadFunc(Var Msg:TMessage); Virtual id_first + fs_FuncList;
    Procedure Ok(Var Msg:TMessage); virtual id_first + id_ok;
    Destructor Done; virtual;
  end;

  PFuncDetailsDlg = ^TFuncDetailsDlg;
  TFuncDetailsDlg = Object(TDialog)
           Fname: Pchar;
           ListBox : PComboBox;
    Constructor Init(Aparent: PwindowsObject; AName : Pchar; FileName : Pchar);
    Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
    Destructor Done; virtual;
  end;

  PFuncStatusDlg = ^TFuncStatusDlg;
  TFuncStatusDlg = Object(TDialog)
     Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
  end;

  PStatusDlg = ^TStatusDlg;
  TStatusDlg = Object(TDialog)
     Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
  end;


  PCombinationDlg = ^TCombinationDlg;
  TCombinationDlg = Object(TDialog)
        List : PListBox;
    Constructor Init(Aparent: PwindowsObject; AName :Pchar);
    Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
    Procedure loadFunc(Var Msg:TMessage); Virtual id_first + st_List;
    Procedure Ok(Var Msg:TMessage); virtual id_first + id_ok;
    Destructor Done; virtual;
  end;

  PMutateDlg = ^TMutateDlg;
  TMutateDlg = Object(TDialog)
        List : PListBox;
    Constructor Init(Aparent: PwindowsObject; AName :Pchar);
    Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
    Procedure loadFunc(Var Msg:TMessage); Virtual id_first + st_List;
    Procedure Ok(Var Msg:TMessage); virtual id_first + id_ok;
    Destructor Done; virtual;
  end;

  PSelectDlg = ^TSelectDlg;
  TSelectDlg = Object(TDialog)
        List : PListBox;
    Constructor Init(Aparent: PwindowsObject; AName :Pchar);
    Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
    Procedure loadFunc(Var Msg:TMessage); Virtual id_first + st_List;
    Procedure Ok(Var Msg:TMessage); virtual id_first + id_ok;
    Destructor Done; virtual;
  end;
  PAbtDlg = ^TAbtDlg;
  TAbtDlg = object(TDialog)
    constructor Init(Aparent: PwindowsObject; AName :Pchar);
  end;

  PGeneralDlg = ^TGeneralDlg;
  TGeneralDlg = Object(TDialog)
    Constructor Init(Aparent: PwindowsObject; AName :Pchar);
    Procedure WmInitDialog(Var Msg:TMessage); virtual wm_initDialog;
    Function CanClose: Boolean ;virtual ;
    Destructor Done; virtual;
  end;
Implementation

Constructor TGetFuncDialog.Init(Aparent: PwindowsObject; AName : Pchar; FileName : Pchar);
Begin
  TDialog.Init(AParent,AName);
  Fname := Filename;
  FList := New(PListBox,InitResource(@Self,fs_FuncList));
End;

Procedure TGetFuncDialog.WmInitDialog(Var Msg:TMessage);
Var
 Temps: String;
 Tempstr : array [0..100] of char;
 f : integer;
Begin
  TDialog.WmInitDialog(Msg);
 SetDlgItemText(Hwindow,fs_DLLName,Fname);
 Str(Eval^.GetFunctionCount,TempS);
 SetDlgItemText(Hwindow,fs_FuncCount,StrPCopy(TempStr,TempS));
 For f := 0 to Eval^.GetFunctionCount-1 do
 Begin
   Eval^.GetFunctionName(f,@TempStr,SizeOf(TempStr));
   FList^.AddString(tempStr);
 end;
End;

Procedure TGetFuncDialog.GetInfo(Var Msg:TMessage);
Var
  FunctionName : array[0..51] of char;
  Params : Pchar;
Begin
  If FList^.GetSelIndex >= 0 Then
  Begin
    Flist^.GetSelString(FunctionName,50);
    If Eval^.SetAlias(FunctionName) Then
    Begin
      Params := Eval^.GetAliasParameters(FunctionName);
      {PARSER PARSEOK IS A MAJOR PROBLEM}
      If (Parser^.ParseOk(Params) = 0) {or True} THen
      Begin
         Application^.ExecDialog(New(PFuncDetailsDlg,
               init(@Self,'FUNCDTLS',FunctionName)));
      End
      Else
      Begin
        BWCCMessageBox(HWindow, 'Function could not be parsed', 'Error',
        mb_Ok or mb_IconExclamation);
      End
    End
    Else
    Begin
      BWCCMessageBox(HWindow, 'Function could not be linked to', 'Error',
      mb_Ok or mb_IconExclamation);
    End;
  end
  Else
    BWCCMessageBox(HWindow, 'No function has been selected', 'Error',
     mb_Ok or mb_IconExclamation);
End;

Procedure TGetFuncDialog.LoadFunc(Var msg:TMessage);
Begin
  If (Msg.wParamlo = fs_funclist) and (Msg.lParamHi = lbn_DblClk)  Then
  Begin
    Ok(msg);
  end;
end;


Procedure TGetFuncDialog.Ok(Var Msg:TMessage);
Var
  FunctionName : array[0..51] of char;
  quant : array[0..10] of char;
  Code : integer;
  S : String;
  f : integer;
  Params : Pchar;
Begin
  Quant[0] := #0;
  If FList^.GetSelIndex >= 0 Then
  Begin
    Flist^.GetSelString(FunctionName,50);
    If Eval^.SetAlias(FunctionName) Then
    Begin
      Params := Eval^.GetAliasParameters(FunctionName);
      If (Parser^.ParseOk(Params) = 0)  Then
      Begin
        If Parser^.GetBitLength = pa_UD Then
        Begin
          If Application^.ExecDialog(New(PInputDialog,init(@Self,'Function Configuration Dialog',
           'Enter Chromosome Length',quant,sizeOf(quant)-1))) = ID_OK Then
          Begin
            S:=StrPas(Quant);  
            Val(S,f,Code);
            If Code <> 0 Then 
            Begin
               MessageBox(Hwindow,'Invalid Value, Should be an integer',
                'Value Error',mb_IconExclamation+mb_ok);
               Exit;
            End;
            If (f < 1) Then
            Begin
               MessageBox(Hwindow,'Value must be positive',
                'Invalid value',mb_IconExclamation+mb_ok);
               Exit;
            End;  
            Info^.SetBitLength(f);
          End
          Else
            Exit;
        End;
        If Parser^.GetParamCount = pa_UD Then
        Begin
          If Application^.ExecDialog(New(PInputDialog,init(@Self,'Function Configuration Dialog',
           'Enter Parameter Count',quant,sizeOf(quant)-1))) = ID_OK Then
          Begin
            S:=StrPas(Quant);  
            Val(S,f,Code);
            If Code <> 0 Then 
            Begin
               MessageBox(Hwindow,'Invalid Value, Should be an integer',
                'Value Error',mb_IconExclamation+mb_ok);
               Exit;
            End;
            If (f < 1) or ( f > 100)Then
            Begin
               MessageBox(Hwindow,'Value must be the range (0-100)',
                'Invalid value',mb_IconExclamation+mb_ok);
               Exit;
            End;  
            Info^.UserCount := f;
          End
          Else
            Exit;
        End;
      End
      Else
      Begin
        Info^.FunctionLoaded := False;
        BWCCMessageBox(Hwindow,'Error with parsing Function','error',
        mb_ok or mb_IconExclamation); 
        exit;
      End;

      If Parser^.parse(Params,GeneList) = 0  Then
      Begin
        Info^.FunctionLoaded := TRUE;
        TDialog.Ok(Msg);
      End
      Else
      Begin
        Info^.FunctionLoaded := False;
        BWCCMessageBox(Hwindow,'Error with final parse of Function','error',
        mb_ok or mb_IconExclamation);
      End;
    end
    Else
    Begin
      Info^.FunctionLoaded := FALSE;
      BWCCMessageBox(Hwindow,'Function couldn''t be linked to','error',
      mb_ok or mb_IconExclamation); 
    End
  end
  Else
    BWCCMessageBox(HWindow, 'No function has been selected', 'Error',
     mb_Ok or mb_IconExclamation);
End;


Destructor TGetFuncDialog.Done;
Begin
  TDialog.done;
End;

Constructor TFuncDetailsDlg.Init(Aparent: PwindowsObject; AName : Pchar; FileName : Pchar);
Begin
  TDialog.Init(AParent,AName);
  Fname := Filename;
  listbox :=  New(PComboBox,initREsource(@Self,fd_param,22));
End;

Procedure TFuncDetailsDlg.WmInitDialog(Var Msg:TMessage);
Var
 Temps: String;
 Tempstr : array [0..100] of char;
 f : integer;
 tmp : Pchar;
Begin
  TDialog.WmInitDialog(Msg);
  SetDlgItemText(Hwindow,fd_Name,Fname);
  If Parser^.Minimize Then
    tmp := 'Minimise Result'
  else
    tmp := 'Maximise Result';

  SetDlgItemText(Hwindow,fd_Purpose,tmp);


  f := Parser^.GetParamCount;
  Begin
    Str(f,TempS);
    SetDlgItemText(Hwindow,fd_Count,StrPCopy(TempStr,TempS));
  End;
  If f = pa_UD Then
    SetDlgItemText(Hwindow,fd_Count,'User Defined');
  If f = pa_NA Then
    SetDlgItemText(Hwindow,fd_Count,'NA');
  If f = pa_Unknown Then
    SetDlgItemText(Hwindow,fd_Count,'Unknown');

  f := Parser^.GetBitLength;
  Begin
    Str(f,TempS);
    SetDlgItemText(Hwindow,fd_Length,StrPCopy(TempStr,TempS));
  End;
  If f = pa_UD Then
    SetDlgItemText(Hwindow,fd_Length,'User Defined');
  If f = pa_NA Then
    SetDlgItemText(Hwindow,fd_Length,'NA');
  If f = pa_Unknown Then
    SetDlgItemText(Hwindow,fd_Length,'Unknown');


  Case Parser^.FunctionType of
    Bitfunc:
      tmp := 'Bit String';
    PackedFunc:
      tmp := 'Packed String';
    VectFunc:
      tmp := 'Vector';
    ValFunc:
      tmp := 'Values';
  end;
  SetDlgItemText(Hwindow,fd_type,tmp);

  For f := 0 to Parser^.GetParamCount-1 Do
  Begin
    ListBox^.AddString(Parser^.GetEntry(f));
  End;
 
End;


Destructor TFuncDetailsDlg.Done;
Begin
  TDialog.done;
End;


Procedure TFuncStatusDlg.WmInitDialog(Var Msg:TMessage);
Begin
  TDialog.WmInitDialog(Msg);
  If Info^.DLLLoaded Then
  Begin
    SetDlgItemText(Hwindow,ft_DLLName,Eval^.DLLName);
    SetDlgItemText(Hwindow,ft_DLLStatus,'Loaded');
  End
  ELse
  Begin
    SetDlgItemText(Hwindow,ft_DLLName,'');
    SetDlgItemText(Hwindow,ft_DLLStatus,'Not Loaded');
  End;
  If Info^.FunctionLoaded Then
  Begin
    SetDlgItemText(Hwindow,ft_FuncName,Eval^.FunctionName);
    SetDlgItemText(Hwindow,ft_FuncStatus,'Linked');
  End
  ELse
  Begin
    SetDlgItemText(Hwindow,ft_FuncName,'');
    SetDlgItemText(Hwindow,ft_FuncStatus,'Not Linked');
  End;
End;

Procedure TStatusDlg.WmInitDialog(Var Msg:TMessage);
Begin
  TDialog.WmInitDialog(Msg);
  If Info^.DLLLoaded Then
  Begin
    SetDlgItemText(Hwindow,ft_DLLName,Eval^.DLLName);
    SetDlgItemText(Hwindow,ft_DLLStatus,'Loaded');
  End
  ELse
  Begin
    SetDlgItemText(Hwindow,ft_DLLName,'');
    SetDlgItemText(Hwindow,ft_DLLStatus,'Not Loaded');
  End;
  If Info^.FunctionLoaded Then
  Begin
    SetDlgItemText(Hwindow,ft_FuncName,Eval^.FunctionName);
    SetDlgItemText(Hwindow,ft_FuncStatus,'Linked');
  End
  ELse
  Begin
    SetDlgItemText(Hwindow,ft_FuncName,'');
    SetDlgItemText(Hwindow,ft_FuncStatus,'Not Linked');
  End;
  If Info^.crossSelected Then
  Begin
    SetDlgItemText(Hwindow,st_CrossType,Cross^.GetFuncname);
    Realset(Hwindow,st_CrossRate,info^.CrossRate,6);
  End
  Else
  Begin
    SetDlgItemText(Hwindow,st_CrossType,'Not Selected');
    SetDlgItemText(Hwindow,st_CrossRate,' ');
  End;

  If Info^.MutateSelected Then
  Begin
    SetDlgItemText(Hwindow,st_MutateType,Mutate^.GetFuncname);
    Realset(Hwindow,st_MutateRate,info^.MutateRate,6);
  End
  Else
  Begin
    SetDlgItemText(Hwindow,st_MutateType,'Not Selected');
    SetDlgItemText(Hwindow,st_MutateRate,' ');
  End;

  If info^.SelectSelected Then
    SetDlgItemText(Hwindow,st_Select,Select^.GetFuncName)
  Else
    SetDlgItemText(Hwindow,st_select,'Not Selected');

  IntSet(Hwindow,st_popsize,info^.PoolSize);


End;

Constructor TCombinationDlg.Init(Aparent: PwindowsObject; AName : Pchar);
Begin
  TDialog.Init(AParent,AName);
  List := New(PListBox,InitResource(@Self,st_List));
End;

Procedure TCombinationDlg.WmInitDialog(Var Msg:TMessage);
Var
 Temps: String;
 Tempstr : array [0..20] of char;
 f : integer;
Begin
 TDialog.WmInitDialog(Msg);
 For F := 0 to Cross^.GetCrossCount-1 do
   List^.AddString(Cross^.GetNameAt(f));

 If info^.CrossSelected Then
 Begin
   Str(Info^.CrossRate:5:5,TempS);
   SetDlgItemText(Hwindow,st_edit,StrPCopy(TempStr,TempS));
   List^.SetSelIndex(List^.SetSelString(Cross^.GetFuncName,-1));
 End
 Else
 Begin
   SetDlgItemText(Hwindow,st_edit,'0.85');
 End;
End;


Procedure TCombinationDlg.LoadFunc(Var msg:TMessage);
Begin
  If (Msg.wParamlo = st_list) and (Msg.lParamHi = lbn_DblClk)  Then
  Begin
    Ok(msg);
  end;
end;


Procedure TCombinationDlg.Ok(Var Msg:TMessage);
Var
  Code : integer;
  FunctionName : Array[0..50] of char;
  Quant : Array[0 .. 8] of char;
  S : String;
  Rate : Real;
Begin
  If List^.GetSelIndex >= 0 Then
  Begin
    Code := GetDlgItemText(Hwindow,st_edit,Quant,8);
    S:=StrPas(Quant);
    Val(S,Rate,Code);
    If Code <> 0 Then 
    Begin
      BWCCMessageBox(Hwindow,'Invalid Rate, Should be a number',
                'Error',mb_IconExclamation+mb_ok);
      Exit;
    End;
    If (Rate < 0) or (Rate > 1) Then
    Begin
      BWCCMessageBox(Hwindow,'Rate must be between 0.0 and 1.0',
                'Inavalid Rate',mb_IconExclamation+mb_ok);
      Exit;
    End;  
    Info^.CrossRate := Rate;
    list^.GetSelString(FunctionName,50);
    Cross^.SetFunc(FunctionName);
    Info^.CrossSelected := TRUE;
    TDialog.Ok(Msg);
  end
  Else
    BWCCMessageBox(HWindow, 'No Cross-Over operator has been selected', 'Error',
     mb_Ok or mb_IconExclamation);
End;


Destructor TCombinationDlg.Done;
Begin
  TDialog.done;
End;

Constructor TMutateDlg.Init(Aparent: PwindowsObject; AName : Pchar);
Begin
  TDialog.Init(AParent,AName);
  List := New(PListBox,InitResource(@Self,st_List));
End;

Procedure TMutateDlg.WmInitDialog(Var Msg:TMessage);
Var
 Temps: String;
 Tempstr : array [0..20] of char;
 f : integer;
Begin
 TDialog.WmInitDialog(Msg);
 For F := 0 to Mutate^.GetMutateCount-1 do
   List^.AddString(Mutate^.GetNameAt(f));

 If info^.MutateSelected Then
 Begin
   Str(Info^.MutateRate:5:5,TempS);
   SetDlgItemText(Hwindow,st_edit,StrPCopy(TempStr,TempS));
   List^.SetSelIndex(List^.SetSelString(Mutate^.GetFuncName,-1));
 End
 Else
 Begin
   SetDlgItemText(Hwindow,st_edit,'0.0005');
 End;
End;


Procedure TMutateDlg.LoadFunc(Var msg:TMessage);
Begin
  If (Msg.wParamlo = st_list) and (Msg.lParamHi = lbn_DblClk)  Then
  Begin
    Ok(msg);
  end;
end;


Procedure TMutateDlg.Ok(Var Msg:TMessage);
Var
  Code : integer;
  FunctionName : Array[0..50] of char;
  Quant : Array[0 .. 8] of char;
  S : String;
  Rate : Real;
Begin
  If List^.GetSelIndex >= 0 Then
  Begin
    Code := GetDlgItemText(Hwindow,st_edit,Quant,8);
    S:=StrPas(Quant);
    Val(S,Rate,Code);
    If Code <> 0 Then 
    Begin
      BWCCMessageBox(Hwindow,'Invalid Rate, Should be a number',
                'Error',mb_IconExclamation+mb_ok);
      Exit;
    End;
    If (Rate < 0) or (Rate > 1) Then
    Begin
      BWCCMessageBox(Hwindow,'Rate must be between 0.0 and 1.0',
                'Inavalid Rate',mb_IconExclamation+mb_ok);
      Exit;
    End;  
    Info^.MutateRate := Rate;
    list^.GetSelString(FunctionName,50);
    Mutate^.SetFunc(FunctionName);
    Info^.MutateSelected := TRUE;
    TDialog.Ok(Msg);
  end
  Else
    BWCCMessageBox(HWindow, 'No Mutatation operator has been selected', 'Error',
     mb_Ok or mb_IconExclamation);
End;


Destructor TMutateDlg.Done;
Begin
  TDialog.done;
End;

Constructor TSelectDlg.Init(Aparent: PwindowsObject; AName : Pchar);
Begin
  TDialog.Init(AParent,AName);
  List := New(PListBox,InitResource(@Self,st_List));
End;

Procedure TSelectDlg.WmInitDialog(Var Msg:TMessage);
Var
 Temps: String;
 Tempstr : array [0..20] of char;
 f : integer;
Begin
 TDialog.WmInitDialog(Msg);
 For F := 0 to Select^.GetSelectCount-1 do
   List^.AddString(Select^.GetNameAt(f));

 If info^.SelectSelected Then
 Begin
   List^.SetSelIndex(List^.SetSelString(Select^.GetFuncName,-1));
 End;
End;


Procedure TSelectDlg.LoadFunc(Var msg:TMessage);
Begin
  If (Msg.wParamlo = st_list) and (Msg.lParamHi = lbn_DblClk)  Then
  Begin
    Ok(msg);
  end;
end;


Procedure TSelectDlg.Ok(Var Msg:TMessage);
Var
  FunctionName : Array[0..50] of char;
Begin
  If List^.GetSelIndex >= 0 Then
  Begin
    list^.GetSelString(FunctionName,50);
    Select^.SetFunc(FunctionName);
    Info^.SelectSelected := TRUE;
    TDialog.Ok(Msg);
  end
  Else
    BWCCMessageBox(HWindow, 'No Selection operator has been selected', 'Error',
     mb_Ok or mb_IconExclamation);
End;


Destructor TSelectDlg.Done;
Begin
  TDialog.done;
End;




Constructor TGeneralDlg.Init(Aparent: PwindowsObject; AName : Pchar);
Begin
  TDialog.Init(AParent,AName);
End;

Procedure TGeneralDlg.WmInitDialog(Var Msg:TMessage);
Begin
 TDialog.WmInitDialog(Msg);
{ If Info^.GeneralOk Then
 Begin}
   Intset(Hwindow,ge_popsize,info^.poolsize);
   Intset(Hwindow,ge_generations,info^.maxgen);
   Intset(Hwindow,ge_Seed,info^.CurrentSeed);
   CheckDlgButton(Hwindow,ge_setSeed,Ord(Info^.SetSeed));
  { Realset(Hwindow,ge_converge,info^.convPoint,4);
 }{End;}
End;


Function TGeneralDlg.CancLose: Boolean;
Var
  temp : integer;
  FunctionName : Array[0..50] of char;
  Quant : Array[0 .. 8] of char;
  S : String;
  Rate : Real;
Begin
  CanClose := False;
  If IntGet(Hwindow,ge_popsize,2,10000,temp,'Population Size') Then
    info^.SetPoolSize(temp)
  else
    Exit;
  If not IntGet(Hwindow,ge_generations,1,10000,info^.maxgen,'Number of generations') Then
    exit;
  If not IntGet(Hwindow,ge_Seed,0,32000,info^.CurrentSeed,'Random Seed') Then
    exit;
{  If not RealGet(Hwindow,ge_converge,0,1,info^.ConvPoint,'Convergence') Then
    exit;
 }
  Info^.SetSeed := Bool(IsdlgButtonChecked(Hwindow,ge_SetSeed));
  CanClose := TRUE;
  Info^.GeneralOk := TRUE;
End;


Destructor TGeneralDlg.Done;
Begin
  TDialog.done;
End;

constructor TAbtDlg.Init(Aparent: PwindowsObject; AName :Pchar);
begin
  inherited Init(AParent,Aname);
end;




End.
