Unit teGraph;
interface
uses
       Gviewdef,Global,Objects,OMemory,OWindows,ODialogs,
WinTypes,WinProcs,Strings,gvgraph1,Gline,Pen;


TYpe
   PproGRaph = ^TproGraph;
   Tprograph = Object(Tgraph)
      Constructor init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
      Procedure NewStats; Virtual;
      Procedure Reset; Virtual;
      end;

Implementation

Constructor Tprograph.init(nInfo:Pinfo;AParent:PWindowsObject;ATitle:Pchar);
Begin
  inherited init(nInfo,AParent,ATitle);
  ax^.SetName('Generation');
  ay^.SetName('Fitness');
  AX^.NumOn := False;
  AY^.Numon := False;
  YSCale := 10;
  XsCale := 10;
  Lines^.Insert(New(PLine,init(New(Ppen,init(PS_SOlid,1,RGB(0,255,0)))))); {av}
  Lines^.Insert(New(PLine,init(New(Ppen,init(PS_SOlid,1,RGB(255,0,0)))))); {worst}
  Lines^.Insert(New(PLine,init(New(Ppen,init(PS_SOlid,1,RGB(0,0,255)))))); {best}
  XAutoMax := True;
  YAutoMin := True;
  XMin := Ginfo^.Generation;
  Xmax := Ginfo^.MaxGen;
  YMin := 1;
  Ymax := 0;
End;

Procedure TPrograph.Reset;
Begin
  inherited Reset;
  XMin := Ginfo^.Generation;
  Xmax := Ginfo^.MaxGen;
  YMin := 1;
  Ymax := 0;
end;

Procedure TPrograph.NewStats;
Begin
  If Ready Then
  Begin
    PLine(Lines^.at(0))^.AddPoint(Ginfo^.Generation,Ginfo^.CurrentAv);
    PLine(Lines^.at(1))^.AddPoint(Ginfo^.Generation,Ginfo^.CurrentWorst);
    PLine(Lines^.at(2))^.AddPoint(Ginfo^.Generation,Ginfo^.CurrentBest);
    SetMinY(Ginfo^.CurrentWorst);
    SetMaxX(Ginfo^.MaxGen);
    inherited NewStats;
  End;
End;

end.