Unit GGeneral;
Interface
Uses WinProcs,Wintypes,Objects,OMemory,OWindows,ODialogs,Strings,Windos;

const
 StatusLineHeight = 20;

type

  PBaseWindow = ^TBaseWindow;
  TBaseWindow = object(TWindow)
    procedure TimerTick; virtual;
    Procedure Reset; virtual;
    Procedure NewStats; virtual;
    Procedure EndRun; virtual;
    Function GetClassName : Pchar; Virtual;
  end;

  PStatusLine = ^TStatusLine;
  TStatusLine = object(TBaseWindow)
    constructor Init(AParent: PWindowsObject);
  {  function  GetClassName: PChar;  virtual;
   } procedure GetWindowClass(var AWndClass : TWndClass); virtual;
    procedure TimerTick;  virtual;
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure SetStatus(nStatus : Pchar);
    procedure AddStatus(nStatus : Pchar);
    Private
      StatusStr : array[0..100] of char;
  end;
Var
    StatusLine : PStatusLine;

Implementation
procedure TBaseWindow.TimerTick;
begin
end;

procedure TBaseWindow.Reset;
begin
end;
procedure TBaseWindow.NewStats;
begin
end;
Procedure TBaseWindow.EndRun;
Begin
End;


function TBaseWindow.GetClassName: PChar;
begin
  GetClassName := 'Gen-child';
end;

constructor TStatusLine.Init(AParent: PWindowsObject);
begin
  TBaseWindow.Init(AParent, '');      { create the window normally }
  SetFlags(wb_MDIChild, False);   {turn off the MDI flag that TWindow set }
  Attr.Style := ws_Border or ws_Child or ws_Visible;
  StatusStr[0]  := #0;
end;

procedure TStatusLine.GetWindowClass(var AWndClass : TWndClass);
begin
  TWindow.GetWindowClass(AWndClass);
  AWndClass.hbrBackGround := GetStockObject(White_Brush);
end;


procedure TstatusLine.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var
  DC: HDC;
  S, Temp: array[0..50] of Char;
  Hour, Minute, Second, hs: Word;
  Width: Integer;
  R : TREct;
Begin
 { Temp[1] := #0; }
  DC := GetDC(HWindow);
  GetClientRect(Hwindow,R);
  GetTime(Hour, Minute, Second, hs);
  Str(Hour: 2, S);
  StrCat(S, ':');
  Str(Minute:2, Temp);
  if Temp[0] = ' ' then Temp[0] := '0';
  StrCat(S, Temp);
  StrCat(S, ':');
  Str(Second:2, Temp);
  if Temp[0] = ' ' then Temp[0] := '0';
  StrCat(S, Temp);
  TextOut(DC, 5, 2, S, StrLen(S));
  Width := LoWord(GetTextExtent(DC, S, StrLen(S)));
  MoveTo(DC, Width + 10, 0);
  LineTo(DC, Width + 10, StatusLineHeight);
  Rectangle(DC,Width+10,-1,R.Right+1,R.Bottom);
{  If StatusStr <> nil  Then   }
   TextOut(DC, Width + 20, 2, StatusStr, StrLen(StatusStr));
  ReleaseDC(HWindow, DC);
    UpdateWindow(Hwindow);
End;


Procedure TStatusline.SetStatus(nStatus : Pchar);
Var
  Temp : TPaintStruct;
  DC : HDC;
Begin
{  If StatusStr <> nil then
    strdispose(StatusStr);
  StatusStr := StrNew(nStatus);  
 } Strlcopy(StatusStr,nStatus,Sizeof(statusStr)-1);   
  Paint(DC,temp);
End;

Procedure TStatusline.AddStatus(nStatus : Pchar);
Var
  Temp : TPaintStruct;
  DC : HDC;
Begin
  StrLCat(StatusStr,nStatus,sizeOf(statusStr)-1);
  Paint(DC,temp);   
End;



procedure TStatusLine.TimerTick;
var
  DC: HDC;
  S, Temp: array[0..100] of Char;
  Hour, Minute, Second, hs: Word;
  Width: Integer;
  R : TREct;
begin
  DC := GetDC(HWindow);
  GetClientRect(Hwindow,R);
  GetTime(Hour, Minute, Second, hs);
  Str(Hour: 2, S);
  StrCat(S, ':');
  Str(Minute:2, Temp);
  if Temp[0] = ' ' then Temp[0] := '0';
  StrCat(S, Temp);
  StrCat(S, ':');
  Str(Second:2, Temp);
  if Temp[0] = ' ' then Temp[0] := '0';
  StrCat(S, Temp);
  TextOut(DC, 5, 2, S, StrLen(S));
  Width := LoWord(GetTextExtent(DC, S, StrLen(S)));
  MoveTo(DC, Width + 10, 0);
  LineTo(DC, Width + 10, StatusLineHeight);
  ReleaseDC(HWindow, DC);

end;
end.